// *********************************************************
// ft_parInt Ver.1                               ft_parInt.h
// *********************************************************
#include <18F14K22.h>
#fuses INTRC_IO, NOWDT, PLLEN, NOBROWNOUT
#device adc=10
#use delay(clock=64Mhz)
#use rs232(baud=9600, timeout=500, xmit=PIN_A0, rcv=PIN_A1)

typedef short bit;
#define m1  6
#define m2  4
#define m3  2
#define m4  0

int _out=0;            // Ausgangsregister fuer 4094
//**********************************************************
#define P_S   PIN_B7   // Interface Pin 7   (4021)
#define Stb   PIN_C7   // Interface Pin 8   (4094)
#define Clk   PIN_C3   // Interface Pin 9   (4021/4094)
#define Dout  PIN_C6   // Interface Pin 10  (4094)
#define Din   PIN_B6   // Interface Pin 17  (4021)
#define IRLed PIN_A2   // via R=39E

#define EX_EY_analog   (sAN10|sAN11) // Analogeingnge
#define _Ex   11       // EX Kanal 10 Interface Pin 13
#define _Ey   10       // EY Kanal 11 Interface Pin 14

//**********************************************************
void SR_out ( byte SR4094 ) {  // CD4094
  byte i;
  for ( i=0; i<8; ++i ) {
    output_bit(Dout,bit_test( SR4094,i));
    delay_us(50); output_bit(Clk,1);
    delay_us(50); output_bit(Clk,0);
  }
  output_bit(Stb,1); delay_us(50); // Datenbergabe
  output_bit(Stb,0);
}

//**** Eingangsport lesen (8bit) ***************************
byte SR_in( void ) {           // CD4021/CD4014
  byte i, dta = 0;
  output_bit(P_S,1);  delay_us(50);
  output_bit(clk,1);
  output_bit(P_S,0);  delay_us(50);
  for ( i=0; i<8; ++i ) {
    output_bit(clk,1); delay_us(10);
    dta>>=1;
    if (input(Din)) dta|=0x80;
    output_bit(clk,0); delay_us(10);
  }
  return dta;
}

//**** Eingangspin lesen ***********************************
bit E( byte x ) { return bit_test(SR_in(),(x&0x07)); }

//**** Motoren EIN-AUS-ZURUECK *****************************
//  mx: m1..m4, dir: 0..2 (aus, vor, zurueck)
void motor ( byte mx, byte dir){
  bit_clear(_out, mx);  bit_clear(_out, mx+1);
  if (dir==1) bit_set(_out, mx);
  if (dir==2) bit_set(_out, mx+1);
  SR_out(_out);
}
